#include "stdafx.h"
#include "RedAverage.h"
//#include <valarray>
//#include <math.h>



int RAverageW::AssessWeights16(int mode, int errlevel, bool silent, IScriptEnvironment* env)
{
// Check size of the parameters
	InvertShift=false;
	double sumposit=0;
	double sumnegat=0;
	double maxposit=0;
	double minnegat=0;
	bool OverFlowThreat=false;
	int zero=0;
	for (unsigned i=0; i < clips.size(); ++i){
		if (clips[i].weight==0)
			zero++;
		else if (clips[i].weight>maxposit) 
			maxposit = clips[i].weight;
		else if (clips[i].weight<minnegat) 
			minnegat = clips[i].weight;
		if (clips[i].weight>0) 
			sumposit += clips[i].weight;
		else
			sumnegat += clips[i].weight;
	}
	if((bias>(1-sumnegat)*maxbit) || (bias<-sumposit*maxbit))
		env->ThrowError("RAverageW: Look at your bias buddy...even PC scale has its limits.");
	double maxabs=( -minnegat>maxposit ? -minnegat : maxposit );
	double maxsum=( -sumnegat>sumposit ? -sumnegat : sumposit );
	double maxtot=( -sumnegat-bias/maxbit>sumposit+bias/maxbit ? -sumnegat-bias/maxbit : sumposit+bias/maxbit );
	if (maxsum*maxbit<0.5)
		env->ThrowError("RAverageW: Seriously, you expect any results with these weights?");
//here calc best scaling to fit in ScaleWMax range
	const int swmx=min(ScaleWMax,65536);
	const int swmxb=min(ScaleWMax,128);
//	const double biascorr=(lsb==1 ? 256 : (lsb==2 ? 1.0/256 : 1));
//	const int biascorrpower=(lsb==1 ? 8 : (lsb==2 ? -8 : 0));
	const int lsbchangepower=(lsb==1 ? 8 : (lsb==2 ? -8 : 0));
	ScaleW_CPower=ceil(log(double((lsb_in ? min(ScaleWMax,65536) : min(ScaleWMax,256))*2*clips.size()))/log(2.0));
	int ScaleW_C=1<<ScaleW_CPower;
	IsSignedW=(round(ScaleW_C*minnegat)<0 ? true : false);
	IsSignedB=(round(ScaleW_C*bias)<0 ? true : false);
	if (!IsSignedB && !IsSignedW) {
		bias=max(bias,0);
		for (unsigned i=0; i < clips.size(); ++i)
			clips[i].weight=max(clips[i].weight,0);
		}
//base scales calc
	int oneScaleW_WPower=int(log(swmx/maxabs)/log(2.0));
	int sumScaleW_WPower=int(log(swmx/maxsum)/log(2.0));
	int totScaleW_WPower=int(log(swmx/maxtot)/log(2.0));
	int oneScaleW_BPower=int(log(swmxb/maxabs)/log(2.0));
	int sumScaleW_BPower=int(log(swmxb/maxsum)/log(2.0));
	int totScaleW_BPower=int(log(swmxb/maxtot)/log(2.0));
	int biaScaleW_WPower=int(log(swmx/(abs(bias)+0.00000001))/log(2.0)+16);
	int biaScaleW_BPower=int(log(swmxb/(abs(bias)+0.00000001))/log(2.0)+8);

	if (pow(2.0,oneScaleW_WPower)*maxabs+0.5>=swmx)
		oneScaleW_WPower--;
	if (pow(2.0,sumScaleW_WPower)*maxsum+0.5>=swmx)
		sumScaleW_WPower--;
	if (pow(2.0,totScaleW_WPower)*maxtot+0.5>=swmx)
		totScaleW_WPower--;
	if (pow(2.0,oneScaleW_BPower)*maxabs+0.5>=swmxb)
		oneScaleW_BPower--;
	if (pow(2.0,sumScaleW_BPower)*maxsum+0.5>=swmxb)
		sumScaleW_BPower--;
	if (pow(2.0,totScaleW_BPower)*maxtot+0.5>=swmxb)
		totScaleW_BPower--;
	if (pow(2.0,biaScaleW_BPower-8)*abs(bias)+0.5>=swmxb)
		biaScaleW_BPower--;
	if (pow(2.0,biaScaleW_WPower-16)*abs(bias)+0.5>=swmx)
		biaScaleW_WPower--;
	if (totScaleW_WPower>oneScaleW_WPower)
		totScaleW_WPower=oneScaleW_WPower;
	if (totScaleW_BPower>oneScaleW_BPower)
		totScaleW_BPower=oneScaleW_BPower;
	if (totScaleW_WPower>biaScaleW_WPower-lsbchangepower)
		totScaleW_WPower=biaScaleW_WPower-lsbchangepower;
	if (totScaleW_BPower>biaScaleW_BPower-lsbchangepower)
		totScaleW_BPower=biaScaleW_BPower-lsbchangepower;/////negative
	int oneScaleW_SWPower=oneScaleW_WPower-1;
	int sumScaleW_SWPower=sumScaleW_WPower-1;
	int totScaleW_SWPower=totScaleW_WPower-1;
//rounding error estimation and proper method selection
	int mm;
	int err[20];
	err[4]=CalcError(totScaleW_BPower,lsbchangepower);
	err[6]=CalcError(sumScaleW_BPower,lsbchangepower);
	err[7]=CalcError(oneScaleW_BPower,lsbchangepower);
	err[8]=CalcError(totScaleW_SWPower,lsbchangepower);
	err[10]=CalcError(sumScaleW_SWPower,lsbchangepower);
	err[11]=CalcError(oneScaleW_SWPower,lsbchangepower);
	err[16]=CalcError(totScaleW_WPower,lsbchangepower);
	err[18]=CalcError(sumScaleW_WPower,lsbchangepower);
	err[19]=CalcError(oneScaleW_WPower,lsbchangepower);

	if (optimize==0) {
				//error report if not silent, else setup the method
		mm=0;
	} else {
		if ((err[4]<=errlevel) && (mode & 4)) {
			mm=4;
			ScaleW_SBPower=totScaleW_BPower;
		//} else if ((err[6]<=errlevel) && (mode & 4)) {
		//	mm=6;
		//	ScaleW_SBPower=sumScaleW_BPower;
		//} else if ((err[7]<=errlevel) && (mode & 4)) {
		//	mm=7;
		//	ScaleW_SBPower=oneScaleW_BPower;
		} else if ((mode & 4) && (((mode | (4)) ^ (4))==0)) { //mode==4, but just to keep it consistent with the following
			//error report if not silent, else setup the method
			if (!silent)
				env->ThrowError(env->Sprintf("RAverageW: Rounding error (%i) too big for method 4. Either increase errlevel or set mode=-1 (other method will be chosen) or mode=0 (for unoptimized algo) or set silent=true (if error is big, filter will silently fall back to unoptimized code...10x slower).",err[4]));
			else 
				//if (err[6]>err[7]) {
				//	mm=7;
				//	ScaleW_SBPower=oneScaleW_BPower;
				//} else if (err[4]>err[6]) {
				//	mm=6;
				//	ScaleW_SBPower=sumScaleW_BPower;
				//} else 
				{
					mm=4;
					ScaleW_SBPower=totScaleW_BPower;
				} 
		} else if ((err[8]<=errlevel) && (mode & 8)) {
			mm=8;
			ScaleW_SWPower=totScaleW_SWPower;
		//} else if ((err[10]<=errlevel) && (mode & 8)) {
		//	mm=10;
		//	ScaleW_SWPower=sumScaleW_SWPower;
		//} else if ((err[11]<=errlevel) && (mode & 8)) {
		//	mm=11;
		//	ScaleW_SWPower=oneScaleW_SWPower;
		} else if ((mode & 8) && (((mode | (8+4)) ^ (8+4))==0)) {
			//error report if not silent, else setup the method
			if (!silent)
				env->ThrowError(env->Sprintf("RAverageW: Rounding error (%i) too big for method 8. Either increase errlevel or set mode=-1 (other method will be chosen) or mode=0 (for unoptimized algo) or set silent=true (if error is big, filter will silently fall back to unoptimized code...10x slower).",err[8]));
			else 
				if ((err[4]>err[8]) || !(mode & 4)) {
					mm=8;
					ScaleW_SWPower=totScaleW_SWPower;
				} else {
					mm=4;
					ScaleW_SBPower=totScaleW_BPower;
				} 
				//if (err[10]>err[11]) {
				//	mm=11;
				//	ScaleW_SWPower=oneScaleW_SWPower;
				//} else if (err[8]>err[10]) {
				//	mm=10;
				//	ScaleW_SWPower=sumScaleW_SWPower;
				//} else if ((err[7]>err[8]) || !(mode & 4)) {
				//	mm=8;
				//	ScaleW_SWPower=totScaleW_SWPower;
				//} else if (err[6]>err[7]) {
				//	mm=7;
				//	ScaleW_SBPower=oneScaleW_BPower;
				//} else if (err[4]>err[6]) {
				//	mm=6;
				//	ScaleW_SBPower=sumScaleW_BPower;
				//} else {
				//	mm=4;
				//	ScaleW_SBPower=totScaleW_BPower;
				//} 
		//} else if ((err[16]<=errlevel) && (mode & 16)) {
		} else {
			//error report if not silent, else setup the method
			if (!silent && (mode!=0))
				env->ThrowError("RAverageW: No method is chosen. Set up parameters or set silent=true (filter will silently fall back to unoptimized code).");
			else 
				mm=0;
		}
	}
	if (mm==7) {
		if (CalcError(ScaleW_SBPower-1,lsbchangepower)<=CalcError(ScaleW_SBPower,lsbchangepower)) 
			ScaleW_SBPower--;
		else
			OverFlowThreat=true;
	} else if (mm==11) {
		if (CalcError(ScaleW_WPower-1,lsbchangepower)<=CalcError(ScaleW_WPower,lsbchangepower)) 
			ScaleW_WPower--;
		else
			OverFlowThreat=true;
	}
	vector<PClip> cs;
	vector<int> swv; 
	if (mm & 4) {//pmaddubsw
		int sw;
		double ScaleW_SB=pow(2.0,ScaleW_SBPower);
		for (unsigned i=0; i < clips.size(); ++i){
			sw=round(clips[i].weight*ScaleW_SB);
			if (sw!=0)	{
				cs.push_back(clips[i].clip);
				swv.push_back(sw);
			}
		}
		ScaleW_SBPower+=lsbchangepower;
		double ScaleW_SBdn=pow(2.0,ScaleW_SBPower);
		if (ScaleW_SBPower>0)
			ScaledBias=round((bias+0.5)*ScaleW_SBdn);
		else
			ScaledBias=round(bias*ScaleW_SBdn);
		if (ScaleW_SBPower<0) {
			ScaleW_SBPower=abs(ScaleW_SBPower);
			InvertShift=true;
		}
	} else if (mm & 8) {//pmaddwd
		int sw;
		double ScaleW_SW=pow(2.0,ScaleW_SWPower);
		for (unsigned i=0; i < clips.size(); ++i){
			sw=round(clips[i].weight*ScaleW_SW);
			if (sw!=0)	{
				cs.push_back(clips[i].clip);
				swv.push_back(sw);
			}
		}
		ScaleW_SWPower+=lsbchangepower;
		double ScaleW_SWdn=pow(2.0,ScaleW_SWPower);
		if (ScaleW_SWPower>0)
			ScaledBias=round((bias+0.5)*ScaleW_SWdn);
		else
			ScaledBias=round(bias*ScaleW_SWdn);
		if (ScaleW_SWPower<0) {
			ScaleW_SWPower=abs(ScaleW_SWPower);
			InvertShift=true;
		}
	} else {
		mm=0;
		int sw;
		if (ScaleW_CPower+lsbchangepower<0)
			ScaleW_CPower=-lsbchangepower;
		double ScaleW_C=pow(2.0,ScaleW_CPower);
		for (unsigned i=0; i < clips.size(); ++i){
			sw=round(clips[i].weight*ScaleW_C);
			if (sw!=0)	{
				cs.push_back(clips[i].clip);
				swv.push_back(sw);
			}
		}
		ScaleW_CPower+=lsbchangepower;
		double ScaleW_Cdn=pow(2.0,ScaleW_CPower);
		if (ScaleW_CPower>0)
			ScaledBias=roundl((bias+0.5)*ScaleW_Cdn);
		else {
			ScaledBias=roundl(bias*ScaleW_Cdn);
		}
	}
	//if (OverFlowThreat) 
	//	reorganize;
	//else
		for (unsigned i=0; i < cs.size(); ++i){
			selectedclips.push_back(cs[i]);
			ScaledWeight.push_back(swv[i]);
		}
//to be removed after asm can handle odd lengths
	if ((mm>0) && (selectedclips.size() % 2 ==1)) {
		selectedclips.push_back(cs[0]);
		ScaledWeight.push_back(0);
	}

	length=selectedclips.size();
return mm;	
/*resulting mm:
0:go for C++ code
4:use pmaddubsw (no overflow will be in sword)
6:use pmaddubsw (sum of clips can be done in sword, but there can be overflow with bias, so should be added as last)
7:use pmaddubsw (no overflow will be per op but the sum should be done in sdoubles, coz there can be overflow)
8:use pmaddwd (no overflow will be in sdwords)
10:use pmaddwd (no overflow will be in sdwords during summation, but there can be overflow with bias, so should be added as last)
11:use pmaddwd (no overflow will be per op but the sum should be done in ????, coz there can be overflow)
8-11:if it is LSB_IN, take care of signed numbers and based of variables IsSignedB(bias) and IsSignedW(weights).
16:use pmulw  (no overflow will be in sdwords)
18:use pmulw  (no overflow will be in sdwords during summation, but there can be overflow with bias, so should be added as last)
19:use pmulw  (no overflow will be per op but the sum should be done in ????, coz there can be overflow)
8-11:if it is LSB_IN, take care of signed numbers and based of variables IsSignedB(bias) and IsSignedW(weights).
*/
}



int RAverageW::CalcError(int scalepower, int lsbcp)
{
	double scaleup=pow(2.0,scalepower);
	double scaledn=pow(2.0,scalepower+lsbcp);
	double errorFloat=0;
	int errorInt=0;
	double errorTemp;
	for (unsigned i=0; i < clips.size(); ++i){
		errorTemp=abs(abs(clips[i].weight)*scaleup-round(abs(clips[i].weight)*scaleup));
		errorFloat+=errorTemp*maxbitsrc;
		errorInt+=ceil(errorTemp*maxbitsrc);
	}
	errorTemp=abs(abs(bias)*scaledn-round(abs(bias)*scaledn));
	errorFloat+=errorTemp*maxbitsrc;
	errorInt+=ceil(errorTemp*maxbitsrc);

	errorFloat=errorFloat/scaledn;
	errorInt=round(double(errorInt)/scaledn);
	return errorInt;
}

