#ifndef __COMMON_FILTER__
#define __COMMON_FILTER__

////#pragma warning(disable:4103) // disable pack to change alignment warning ( stlport related )

#define			NO_OPERATION	1
#define			COPY_SOURCE_1	2
#define			OPERATION		3
#define			COPY_SOURCE_2	4
#define			COPY_SOURCE_3	5

#define  CPUF_SSSE3         0x200   //  Core 2
#define  CPUF_SSE4			0x400   //  Penryn, Wolfdale, Yorkfield
#define  CPUF_SSE4_1		0x400
#define  CPUF_SSE4_2		0x800   //  Nehalem

#define YUVidx(a) (a<=0 ? -1 : (a==3 ? -1 : (yuv>3 ? yuv-3 : yuv-2)))

#define round(a) int(a+(a<0 ? -0.5 : 0.5))
#define roundl(a) long long(a+(a<0 ? -0.5 : 0.5))
#define ceill(a) long long(a+(a<0 ? -0.9999 : 0.9999))
#define ceil(a) int(a+(a<0 ? -0.9999 : 0.9999))

const int PitchAlign=32;
const int MaxLen=64;






struct WeightedClip
{
	PClip clip;
	double weight;
		WeightedClip(PClip _clip, double _weight)
		: clip(_clip), weight(_weight) {}
};



class CommonFilter : public GenericVideoFilter {
protected:
	vector<PVideoFrame> frames;
	vector<PClip> clips;
	PVideoFrame	result;
	double bias;
	int Y, U, V;
	bool lsb_in, lsb_out;
	int maxbitin, maxbitout, length, lsb;
	int optimize;//, special;
	char *filterName;

	void ChooseDestination(IScriptEnvironment *env);
	void CheckFrameSize(IScriptEnvironment *env);
	void CheckSSE(int _sse, IScriptEnvironment *env);

	virtual void ProcessPlane(int plane, IScriptEnvironment* env)=0;
	void DontProcessPlane(int plane, int yuv, IScriptEnvironment* env);
	void ProcessFrame(IScriptEnvironment* env, VideoInfo vi);
public:
	CommonFilter(PClip _child, vector<PClip> _clips, double _bias, int _y, int _u, int _v, int _sse, bool _lsb_in, bool _lsb_out, IScriptEnvironment *env, const char *name);
};



#endif
