//version P works incorrectly, but why is 30% faster?

#include "defsetupM.h"

#define PTRSIZE 4
//#define DATASTEP (REGSIZE/2)
#define DATASTEP (REGSIZE)
#define TEMPSTEP 4*PTRSIZE

#ifdef LSB_IN
	#ifdef LSB_OUT
		int roundedbias=int ((bias+0.5)*(1<<8)+0.5);
		int SCPW=8;
	#else
		int roundedbias=int ((bias+0.5)*(1<<16)+0.5);
		int SCPW=16;
	#endif
#else
	#ifdef LSB_OUT
		int roundedbias=int ((bias+0.5));
		int SCPW=0;
	#else
		int roundedbias=int ((bias+0.5)*(1<<8)+0.5);
		int SCPW=8;
	#endif
#endif

_declspec(align(16)) int rounder[4];
_declspec(align(16)) unsigned char shufmask[16];
_declspec(align(16)) unsigned char* rowendptrs[(MaxLen+2)*4];// needs constant :-(

int length16=(length)*TEMPSTEP;
int length16P=length16+TEMPSTEP;
int alignwidth=DATASTEP*int((width+DATASTEP-1)/DATASTEP);
int negalignwidth=-alignwidth;

for (int j=0;j<4;++j)
	rounder[j] = roundedbias;
for (int i=0;i<8;++i){
	shufmask[i]=2*i;
	shufmask[i+8]=2*i+1;
}
#ifndef SSE4_PROC
	#ifdef LSB_OUT
	for (int j=0;j<4;j++) {							//alignment/size of char
		rounder[j]-=(0x00008000<<SCPW);
	}
	#endif
#endif

for (int i=0;i<(length+2)*4;++i)
	rowendptrs[i]=frameptrs[i]+alignwidth;
rowendptrs[2]=shufmask;//so at the end of the cycle I can endup with pointers to shufmask and rounder in mask pointers
rowendptrs[3]=(unsigned char*)rounder;

int y_cnt=s_height;

__asm
{
pushad

movdqa		xmm7, qword ptr [rounder]
mov		esi, [length16]

LABEL_VERTICAL:
	mov		edi, [negalignwidth]
LABEL_HORIZONTAL:
		mov		eax, [rowendptrs+esi]        //loading data here
		mov		ecx, [rowendptrs+esi+8]
		#ifdef LSB_IN
		mov		ebx, [rowendptrs+esi+4]
		mov		edx, [rowendptrs+esi+12]
		#endif
		movdqa		xmm6, xmm7
		movdqa		xmm4, xmm7
		movdqa		xmm5, xmm7

LABEL_TEMPORAL:
		#ifdef LSB_IN
			movdqa		xmm1, qword ptr [eax+edi]//clip msb
			movdqa		xmm0, qword ptr [ebx+edi]//clip lsb
			movdqa		xmm3, qword ptr [ecx+edi]//mask msb
			movdqa		xmm2, qword ptr [edx+edi]//mask lsb
						//time to do something
			punpckhbw   xmm0, xmm1    //clip   7766554433221100 8...f
			punpckhbw   xmm2, xmm3    //mask   7766554433221100 8...f
			movdqa      xmm1, xmm0
			pmullw      xmm0, xmm2    //       l7l6l5l4l3l2l1l0
			pmulhuw     xmm1, xmm2    //       h7h6h5h4h3h2h1h0
						//time to do something
			movdqa      xmm2, xmm0
			punpcklwd   xmm0, xmm1    //       h3l3h2l2h1l1h0l0
			punpckhwd   xmm2, xmm1    //       h7l7h6l6h5l5h4l4
			psrld       xmm0, 8      // To have some space for accumulating upto 256 values
			psrld       xmm2, 8   
			paddd       xmm6, xmm0    //accumulating values
			paddd       xmm7, xmm2

			movq		xmm1, qword ptr [eax+edi]//clip msb
			movq		xmm0, qword ptr [ebx+edi]//clip lsb
			movq		xmm3, qword ptr [ecx+edi]//mask msb
			movq		xmm2, qword ptr [edx+edi]//mask lsb
						//time to do something
			sub		esi, TEMPSTEP
			punpcklbw   xmm0, xmm1    //clip   7766554433221100  0...7
			punpcklbw   xmm2, xmm3    //mask   7766554433221100  0...7
			movdqa      xmm1, xmm0
			pmullw      xmm0, xmm2    //       l7l6l5l4l3l2l1l0
			pmulhuw     xmm1, xmm2    //       h7h6h5h4h3h2h1h0
						//time to do something
			mov		eax, [rowendptrs+esi]        //loading data here
			mov		ebx, [rowendptrs+esi+4]
			mov		ecx, [rowendptrs+esi+8]
			mov		edx, [rowendptrs+esi+12]
			movdqa      xmm2, xmm0
			punpcklwd   xmm0, xmm1    //       h3l3h2l2h1l1h0l0  0...3
			punpckhwd   xmm2, xmm1    //       h7l7h6l6h5l5h4l4  4...7
			psrld       xmm0, 8      // To have some space for accumulating upto 256 values
			psrld       xmm2, 8   
			paddd       xmm4, xmm0    //        -333-222-111-000                          accumulating values
			paddd       xmm5, xmm2    //        -777-666-555-444
		#else
			movdqa		xmm1, qword ptr [eax+edi]//clip msb
			movdqa		xmm3, qword ptr [ecx+edi]//mask msb
						//time to do something
			pxor		xmm0, xmm0//-----------------------------
			pxor		xmm2, xmm2//-----------------------------
			punpckhbw   xmm0, xmm1    //clip   7-6-5-4-3-2-1-0- 8...f
			punpckhbw   xmm2, xmm3    //mask   7-6-5-4-3-2-1-0- 8...f
			pmulhuw     xmm0, xmm2    //       h7h6h5h4h3h2h1h0 8...f
						//time to do something
			sub		esi, TEMPSTEP
			pxor		xmm2, xmm2//-----------------------------
			punpcklbw   xmm3, xmm2    //mask   -7-6-5-4-3-2-1-0 0...7
			punpcklbw   xmm1, xmm2    //clip   -7-6-5-4-3-2-1-0 0...7
			pmullw      xmm1, xmm3    //       l7l6l5l4l3l2l1l0 0...7
						//time to do something
			mov		eax, [rowendptrs+esi]        //loading data here
			mov		ecx, [rowendptrs+esi+8]

			movdqa		xmm3, xmm0
			punpckhwd   xmm0, xmm2    //       --ff--ee--dd--cc
			punpcklwd   xmm3, xmm2    //       --bb--aa--99--88
			paddd       xmm6, xmm3
			paddd       xmm7, xmm0

			movdqa		xmm3, xmm1
			punpcklwd   xmm1, xmm2    //       --33--22--11--00
			punpckhwd   xmm3, xmm2    //       --77--66--55--44
			paddd       xmm4, xmm1
			paddd       xmm5, xmm3
		#endif
			jnz LABEL_TEMPORAL

#ifdef LSB_OUT
#ifdef LSB_IN
		psrad		xmm6, 8          
		psrad		xmm7, 8
		psrad		xmm4, 8			//          --33--22--11--00
		psrad		xmm5, 8			//			--77--66--55--44
#endif
		mov		esi, [length16]
#ifdef SSE4_PROC
		packusdw	xmm6, xmm7                  ////////////////// SSE 4.1
		packusdw	xmm4, xmm5                  ////////////////// SSE 4.1      7766554433221100
#else
		pcmpeqd		xmm1, xmm1		// 0xFFFFFFFF
		psllw		xmm1, 15		// 0x80008000
		packssdw	xmm6, xmm7
		packssdw	xmm4, xmm5
		paddw		xmm6, xmm1
		paddw		xmm4, xmm1
#endif
#ifndef LSB_IN
	mov		ebx, [rowendptrs+4]
#endif
#ifdef SSE3_PROC
		movdqa		xmm2, qword ptr [shufmask]
		pshufb		xmm6, xmm2                    //////////////// SSSE3
		pshufb		xmm4, xmm2                    //////////////// SSSE3
		movdqa		xmm5, xmm4
		unpckhpd	xmm4, xmm6
		unpcklpd	xmm5, xmm6
#else
		movdqa	xmm7, xmm6		//ffeeddccbbaa9988
		movdqa	xmm5, xmm4		//7766554433221100
		psllw		xmm7, 8		//f-e-d-c-b-a-9-8-low
		psllw		xmm5, 8		//7-6-5-4-3-2-1-0-low
		psrlw		xmm6, 8		//-f-e-d-c-b-a-9-8high
		psrlw		xmm4, 8		//-7-6-5-4-3-2-1-0high
		psrlw		xmm7, 8		//-f-e-d-c-b-a-9-8low
		psrlw		xmm5, 8		//-7-6-5-4-3-2-1-0low
		packuswb	xmm5, xmm7
		packuswb	xmm4, xmm6
#endif
		movdqa		xmm7, qword ptr [rounder]
		movdqa		xmmword ptr  [eax+edi], xmm4          //top area
		movdqa		xmmword ptr  [ebx+edi], xmm5         //storing data //bottom area
#else
#ifndef LSB_IN
		psrad		xmm6, 8          
		psrad		xmm7, 8
		psrad		xmm4, 8			//          --33--22--11--00
		psrad		xmm5, 8			//			--77--66--55--44
#endif
		mov		esi, [length16]
		packuswb	xmm6, xmm7
		packuswb	xmm4, xmm5		//			7+6+5+4+3+2+1+0+
		movdqa		xmm7, qword ptr [rounder]
#ifdef LSB_IN
		psrlw		xmm6, 8		//			
		psrlw		xmm4, 8		//          -7-6-5-4-3-2-1-0
#endif
		packuswb	xmm4, xmm6		//			fedcba9876543210
		movdqa		xmmword ptr  [eax+edi], xmm4          //top area
#endif
		add		edi, DATASTEP
		jnz LABEL_HORIZONTAL

LABEL_PITCHCYCLE:                           //next line, so here increasing pitch
		movdqa      xmm1, xmmword ptr [rowendptrs+esi]
		paddd		xmm1, xmmword ptr [pitches+esi]
		movdqa      xmmword ptr [rowendptrs+esi], xmm1
		sub		esi, TEMPSTEP
		jnz	LABEL_PITCHCYCLE
	movdqa      xmm1, xmmword ptr [rowendptrs]
	paddd		xmm1, xmmword ptr [pitches]
	movdqa      xmmword ptr [rowendptrs], xmm1

	dec		y_cnt
	mov		esi, [length16]
	jnz LABEL_VERTICAL

emms
popad
}
#include "defresetM.h"