#include "stdafx.h"
#include "RedAverage.h"


//PVideoFrame RAverageM::WeightedAverageM16(const vector<PVideoFrame> &data, double _bias, int Y, int U, int V, int sse, bool lsb_in, bool lsb_out, IScriptEnvironment* env, VideoInfo vi)
//PVideoFrame RAverageM::WeightedAverageM16(const vector<PVideoFrame> &data, IScriptEnvironment* env, VideoInfo vi)
PVideoFrame RAverageM::WeightedAverageM16(IScriptEnvironment* env, VideoInfo vi)
{
	result = env->NewVideoFrame (vi,PitchAlign);

	if (Y==3) AveragePlaneM16(PLANAR_Y, env);
	if (U==3) AveragePlaneM16(PLANAR_U, env);
	if (V==3) AveragePlaneM16(PLANAR_V, env);

	return (result);
}



void RAverageM::AveragePlaneM16(int plane, IScriptEnvironment* env)
{
	_declspec(align(16)) int pitches[(MaxLen+1)*4];
	_declspec(align(16)) unsigned char* frameptrs[(MaxLen+2)*4];
//	_declspec(align(16)) const unsigned char* frameptrs[(MaxLen+1)*4];


	for (int i=0;i<length;++i){
		pitches[(i+1)*4] = frames[i*2]->GetPitch(plane);
		pitches[(i+1)*4+1] = frames[i*2]->GetPitch(plane);
		pitches[(i+1)*4+2] = frames[i*2+1]->GetPitch(plane);
		pitches[(i+1)*4+3] = frames[i*2+1]->GetPitch(plane);
	}
	pitches[0] = result->GetPitch(plane);
	pitches[1] = result->GetPitch(plane);
	pitches[2] = 0;
	pitches[3] = 0;

	const int src_width=frames[1]->GetRowSize(plane);
	const int dst_width=result->GetRowSize(plane);
	const int width=src_width;
	const int src_height=frames[1]->GetHeight(plane);/////////////////////////////
	const int dst_height=result->GetHeight(plane);
	const int s_height=(lsb_in ? src_height/2 : src_height );
	const int d_height=(lsb_out? dst_height/2 : dst_height );

	for (int i=0;i<length;++i){
		frameptrs[(i+1)*4] = (unsigned char*) frames[i*2]->GetReadPtr(plane);
 		frameptrs[(i+1)*4+1] = frameptrs[(i+1)*4]+pitches[(i+1)*4]*src_height/2;
		frameptrs[(i+1)*4+2] = (unsigned char*) frames[i*2+1]->GetReadPtr(plane);
		frameptrs[(i+1)*4+3] = frameptrs[(i+1)*4+2]+pitches[(i+1)*4+2]*src_height/2;
	}
	frameptrs[0] = result->GetWritePtr(plane);
	frameptrs[1] = frameptrs[0]+pitches[0]*dst_height/2;
	frameptrs[2] = 0;//frameptrs[(length)*4+2];//already to start next round
	frameptrs[3] = 0;//frameptrs[(length)*4+3];//already to start next round

//	if (special==-1) {
//	} else 
	if (optimize & 16) {    //SSE4
		#define SSE4_PROC
		#define SSE3_PROC
		#define SSE2_PROC
		switch (lsb)
		{
		case 1://16bit in 8bit out
			{
				#define LSB_IN
				#undef LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_IN
			}
			break;
		case 2://8bit in 16bit out
			{
				#undef LSB_IN
				#define LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_OUT
			}
			break;
		case 3://16bit in 16bit out
			{
				#define LSB_IN
				#define LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_OUT
				#undef LSB_IN
			}
			break;
		default://8bit in 8bit out
			{
				#undef LSB_OUT
				#undef LSB_IN
				#include "WAM16asm.hpp"
			}
		}
		#undef SSE4_PROC
		#undef SSE3_PROC
		#undef SSE2_PROC
	} else if (optimize & 8) {    //SSE3
		#define SSE3_PROC
		#define SSE2_PROC
		switch (lsb)
		{
		case 1://16bit in 8bit out
			{
				#define LSB_IN
				#undef LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_IN
			}
			break;
		case 2://8bit in 16bit out
			{
				#undef LSB_IN
				#define LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_OUT
			}
			break;
		case 3://16bit in 16bit out
			{
				#define LSB_IN
				#define LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_OUT
				#undef LSB_IN
			}
			break;
		default://8bit in 8bit out
			{
				#undef LSB_OUT
				#undef LSB_IN
				#include "WAM16asm.hpp"
			}
		}
		#undef SSE3_PROC
		#undef SSE2_PROC
	} else if (optimize & 4) {    //SSE2
		#define SSE2_PROC
		switch (lsb)
		{
		case 1://16bit in 8bit out
			{
				#define LSB_IN
				#undef LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_IN
			}
			break;
		case 2://8bit in 16bit out
			{
				#undef LSB_IN
				#define LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_OUT
			}
			break;
		case 3://16bit in 16bit out
			{
				#define LSB_IN
				#define LSB_OUT
				#include "WAM16asm.hpp"
				#undef LSB_OUT
				#undef LSB_IN
			}
			break;
		default://8bit in 8bit out
			{
				#undef LSB_OUT
				#undef LSB_IN
				#include "WAM16asm.hpp"
			}
		}
		#undef SSE2_PROC
//	} else if (optimize & 2) {    //SSE
//	} else if (optimize & 1) {    //MMX
	} else {
		#include "WAM16cpp.hpp"
	}
}