#ifdef SSE4_PROC
	#ifndef SSE4_DEF
		#define SSE4_DEF
		#define REGSIZE 16
		#define MOVALL movdqa
		#define MOVHALF movq
		#define xm0 xmm0
		#define xm1 xmm1
		#define xm2 xmm2
		#define xm3 xmm3
		#define xm4 xmm4
		#define xm5 xmm5
		#define xm6 xmm6
		#define xm7 xmm7
	#endif
#elif defined SSE3_PROC
	#ifndef SSE3_DEF
		#define SSE3_DEF
		#define REGSIZE 16
		#define MOVALL movdqa
		#define MOVHALF movq
		#define xm0 xmm0
		#define xm1 xmm1
		#define xm2 xmm2
		#define xm3 xmm3
		#define xm4 xmm4
		#define xm5 xmm5
		#define xm6 xmm6
		#define xm7 xmm7
	#endif
#elif defined SSE2_PROC
	#ifndef SSE2_DEF
		#define SSE2_DEF
		#define REGSIZE 16
		#define MOVALL movdqa
		#define MOVHALF movq
		#define xm0 xmm0
		#define xm1 xmm1
		#define xm2 xmm2
		#define xm3 xmm3
		#define xm4 xmm4
		#define xm5 xmm5
		#define xm6 xmm6
		#define xm7 xmm7
	#endif
#elif defined SSE1_PROC
	#ifndef SSE1_DEF
		#define SSE1_DEF
		#define REGSIZE 16
		#define MOVALL movdqa
		#define MOVHALF movq
		#define xm0 xmm0
		#define xm1 xmm1
		#define xm2 xmm2
		#define xm3 xmm3
		#define xm4 xmm4
		#define xm5 xmm5
		#define xm6 xmm6
		#define xm7 xmm7
	#endif
#elif defined MMX_PROC
	#ifndef MMX_DEF
		#define MMX_DEF
		#define REGSIZE 8
		#define MOVALL movq
		#define MOVHALF movd
		#define xm0 mm0
		#define xm1 mm1
		#define xm2 mm2
		#define xm3 mm3
		#define xm4 mm4
		#define xm5 mm5
		#define xm6 mm6
		#define xm7 mm7
	#endif
#endif

//asm labels definition

#ifdef SSE4_PROC
	#ifdef LSB_IN
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_4_3
			#define LABEL_VERTICAL vertical_4_3
			#define LABEL_HORIZONTAL horizontal_4_3
			#define LABEL_TEMPORAL temporal_4_3
		#else
			#define LABEL_PITCHCYCLE pitchcycle_4_1
			#define LABEL_VERTICAL vertical_4_1
			#define LABEL_HORIZONTAL horizontal_4_1
			#define LABEL_TEMPORAL temporal_4_1
		#endif
	#else
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_4_2
			#define LABEL_VERTICAL vertical_4_2
			#define LABEL_HORIZONTAL horizontal_4_2
			#define LABEL_TEMPORAL temporal_4_2
		#else
			#define LABEL_PITCHCYCLE pitchcycle_4_0
			#define LABEL_VERTICAL vertical_4_0
			#define LABEL_HORIZONTAL horizontal_4_0
			#define LABEL_TEMPORAL temporal_4_0
		#endif
	#endif
#elif defined SSE3_PROC
	#ifdef LSB_IN
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_3_3
			#define LABEL_VERTICAL vertical_3_3
			#define LABEL_HORIZONTAL horizontal_3_3
			#define LABEL_TEMPORAL temporal_3_3
		#else
			#define LABEL_PITCHCYCLE pitchcycle_3_1
			#define LABEL_VERTICAL vertical_3_1
			#define LABEL_HORIZONTAL horizontal_3_1
			#define LABEL_TEMPORAL temporal_3_1
		#endif
	#else
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_3_2
			#define LABEL_VERTICAL vertical_3_2
			#define LABEL_HORIZONTAL horizontal_3_2
			#define LABEL_TEMPORAL temporal_3_2
		#else
			#define LABEL_PITCHCYCLE pitchcycle_3_0
			#define LABEL_VERTICAL vertical_3_0
			#define LABEL_HORIZONTAL horizontal_3_0
			#define LABEL_TEMPORAL temporal_3_0
		#endif
	#endif
#elif defined SSE2_PROC
	#ifdef LSB_IN
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_2_3
			#define LABEL_VERTICAL vertical_2_3
			#define LABEL_HORIZONTAL horizontal_2_3
			#define LABEL_TEMPORAL temporal_2_3
		#else
			#define LABEL_PITCHCYCLE pitchcycle_2_1
			#define LABEL_VERTICAL vertical_2_1
			#define LABEL_HORIZONTAL horizontal_2_1
			#define LABEL_TEMPORAL temporal_2_1
		#endif
	#else
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_2_2
			#define LABEL_VERTICAL vertical_2_2
			#define LABEL_HORIZONTAL horizontal_2_2
			#define LABEL_TEMPORAL temporal_2_2
		#else
			#define LABEL_PITCHCYCLE pitchcycle_2_0
			#define LABEL_VERTICAL vertical_2_0
			#define LABEL_HORIZONTAL horizontal_2_0
			#define LABEL_TEMPORAL temporal_2_0
		#endif
	#endif
#elif defined SSE1_PROC
	#ifdef LSB_IN
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_1_3
			#define LABEL_VERTICAL vertical_1_3
			#define LABEL_HORIZONTAL horizontal_1_3
			#define LABEL_TEMPORAL temporal_1_3
		#else
			#define LABEL_PITCHCYCLE pitchcycle_1_1
			#define LABEL_VERTICAL vertical_1_1
			#define LABEL_HORIZONTAL horizontal_1_1
			#define LABEL_TEMPORAL temporal_1_1
		#endif
	#else
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_1_2
			#define LABEL_VERTICAL vertical_1_2
			#define LABEL_HORIZONTAL horizontal_1_2
			#define LABEL_TEMPORAL temporal_1_2
		#else
			#define LABEL_PITCHCYCLE pitchcycle_1_0
			#define LABEL_VERTICAL vertical_1_0
			#define LABEL_HORIZONTAL horizontal_1_0
			#define LABEL_TEMPORAL temporal_1_0
		#endif
	#endif
#elif defined MMX_PROC
	#ifdef LSB_IN
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_M_3
			#define LABEL_VERTICAL vertical_M_3
			#define LABEL_HORIZONTAL horizontal_M_3
			#define LABEL_TEMPORAL temporal_M_3
		#else
			#define LABEL_PITCHCYCLE pitchcycle_M_1
			#define LABEL_VERTICAL vertical_M_1
			#define LABEL_HORIZONTAL horizontal_M_1
			#define LABEL_TEMPORAL temporal_M_1
		#endif
	#else
		#ifdef LSB_OUT
			#define LABEL_PITCHCYCLE pitchcycle_M_2
			#define LABEL_VERTICAL vertical_M_2
			#define LABEL_HORIZONTAL horizontal_M_2
			#define LABEL_TEMPORAL temporal_M_2
		#else
			#define LABEL_PITCHCYCLE pitchcycle_M_0
			#define LABEL_VERTICAL vertical_M_0
			#define LABEL_HORIZONTAL horizontal_M_0
			#define LABEL_TEMPORAL temporal_M_0
		#endif
	#endif
#endif
